#include <time.h>

#define CHKR_NOPIECE		0x0000
#define CHKR_CHECKER		0x0001
#define CHKR_KING		0x0002
#define CHKR_NOCOLOR		0x0000
#define CHKR_BLACK		0x0004
#define CHKR_WHITE		0x0008
#define CHKR_BLACKCHECKER	(CHKR_BLACK | CHKR_CHECKER)
#define CHKR_BLACKKING		(CHKR_BLACK | CHKR_KING)
#define CHKR_WHITECHECKER	(CHKR_WHITE | CHKR_CHECKER)
#define CHKR_WHITEKING		(CHKR_WHITE | CHKR_KING)
#define CHKR_SQUARE(x,y)       	(((y) * 8) + (x))

typedef unsigned char		byte;
typedef unsigned int		word;
typedef unsigned long long	dword;
#undef FALSE
#undef TRUE
typedef enum { FALSE, TRUE }	Boolean;

typedef struct {
  int  from;
  int  to;
} Move;

void		chkr_init();
void		chkr_deInit();
int		chkr_nPieces(int mask = CHKR_BLACK | CHKR_WHITE);
int		chkr_depth();
word		chkr_nBoards();
word		chkr_nSeconds();
word		chkr_boardsPerSecond();
void		chkr_setNextToMove(int color);
int		chkr_nextToMove();
void		chkr_clearBoard();
void		chkr_getSquare(int sq, int *color, int *piece);
void		chkr_setSquare(int sq, int color, int piece);
int		chkr_isValidMove(int color, Move mv);
int		chkr_material(int color);
int		chkr_hasWon(int color);
int		chkr_drawn();
int		chkr_canMove(int color);
void		chkr_movePiece(Move mv);
Move		chkr_translateMove(Move mv);
Move		chkr_bestMove(int color, time_t max_time, int max_extend);
